#include <iostream>
#include <string>
#include "Document.h"
#include "Node.h"
#include <fstream>
#include <chrono>

using namespace std;

std::string loadFileToString(const std::string &filename){
	std::ifstream t(filename);
	t.seekg(0, std::ios::end);
	size_t size = t.tellg();
	std::string buffer(size, ' ');
	t.seekg(0);
	t.read(&buffer[0], size); 
	return buffer;
}


int main(int argc, char * argv[])
{
  string html = loadFileToString("./html/coinmarketcapAll.html");
  std::string &page=html;
   // page("<h1><a>some link</a></h1>");
  CDocument doc;
  auto start= chrono::system_clock::now();
  doc.parse(page.c_str());
  auto startcss= chrono::system_clock::now();
  CSelection c = doc.find("div");
  auto end= chrono::system_clock::now();
  
  cout<<"numResults: "<<c.nodeNum()<<endl;
  cout<<"Time Parse : "<<chrono::duration_cast<chrono::microseconds>(startcss-start).count()<< " microseconds."<<endl;
  cout<<"Time CSS   : "<<chrono::duration_cast<chrono::microseconds>(end-startcss).count()<< " microseconds."<<endl;

  return 0;
}

// int main() {
//
// 	std::string &someHtmlString = html;
// 	std::string someSelectorString = "div";
// 	auto testDocument = gq::Document::Create();
// 	auto start= chrono::system_clock::now();
// 	testDocument->Parse(someHtmlString);
// 	auto startcss= chrono::system_clock::now();
//
// 	try
// 	{
// 		auto results = testDocument->Find(someSelectorString);
// 		const auto numResults = results.GetNodeCount();
// 		cout<<"numResults: "<<numResults<<endl;
// 	}
// 	catch(std::runtime_error& e)
// 	{
// 		throw e;
// 		// Necessary because naturally, the parser can throw.
// 	}
//
//
// 	auto end= chrono::system_clock::now();
// 	cout<<"Time Parse : "<<chrono::duration_cast<chrono::microseconds>(startcss-start).count()<< " microseconds."<<endl;
// 	cout<<"Time CSS   : "<<chrono::duration_cast<chrono::microseconds>(end-startcss).count()<< " microseconds."<<endl;
//
// 	return 0;
// }
